<?php

require_once('conf.php');
include('Zend/Pdf.php');

$user = '';
$apiuser = '';
$apipass = '';
$dyrektywy = array();

function getJson($isf) {
	global $user;

	$isfHash = hash('sha256', $isf);
	$time = time();
	$requestHash = getHash($user . $isfHash . '%' . $time);
	$contents = array(
	    'user' => $user,
	    'isf' => $isf,
	    'time' => $time,
	    'hash' => $requestHash
	);
//	error_log('isf-return=' . print_r($isf, true));
	return json_encode($contents);
}

function getHash($str) {
	global $apiuser, $user, $apipass;

	$client = new SoapClient(apiExtUrl);

    $params = array(
	   	"token" => array(
      		"UserName" => $apiuser,
      		"Password" => $apipass
      	),
      	"encodeStringRequest" => array(
	    	"InputData" => $str
	    )      		
	);
	error_log(print_r($params, true));

    $response = $client->__soapCall("EncodeString", array($params));
    error_log(print_r($response, true));        	
	if(isset($response->EncodeStringResult->responseDescription) && ($response->EncodeStringResult->responseDescription != 'Success')) {
    	return '';
	}
	return $response->EncodeStringResult->OutputData;	
}

function doEvent($ev) {
	global $doc, $xpath, $apiuser, $apipass, $dyrektywy;

	error_log(" event id=" . $ev->getAttribute('id') . " type=" . $ev->getAttribute('type'));
	if(($ev->getAttribute('type') == 'order') || ($ev->getAttribute('type') == 'rma')) {
		try {
			$nshi = getNode('shipment', $ev);
			if($nshi->getAttribute('carrier') != carrier) continue;
	
			$snaz = getVal('sender/address/name', $ev);
			$sfir = getVal('sender/address/company', $ev);
			$rnaz = getVal('receiver/address/name', $ev);
			$rfir = getVal('receiver/address/company', $ev);
			$pobranie = getVal('shipment/pickup/cod/amount', $ev);
			if($pobranie == '') $pobranie = 0;
			if(($pobranie != 0) && (getVal('shipment/pickup/cod/amount/@currency', $ev) != 'PLN')) {
				addErr($ev, 'E003', 'Currency not supported', 'Currency not supported', '/event/shipment/pickup/cod/amount/@currency');
        		return false;
			}
			if(getVal('sender/address/country', $ev) != 'PL') {
				addErr($ev, 'E005', 'Country not supported', 'Country not supported', '/event/sender/address/country');
				return false;
			}
				
			$konto = getVal('shipment/pickup/cod/transfer_account_id', $ev);
			$konto = str_replace(' ', '', $konto);
			if(($konto != '') && (strlen($konto) != 26)) {
				addErr($ev, 'E004', 'Invalid account number', 'Invalid account number', '/event/shipment/pickup/cod/transfer_account_id');
				return false;
			}
			if($konto == '') $konto = '0';
			
			$ubez = getVal('shipment/additional_services/insurance', $ev);
			if($ubez == '') $ubez = '0';
	
			$client = new SoapClient(apiUrl, array('trace' => 1));
	
	        $params = array(
	        	"token" => array(
		      		"UserName" => $apiuser,
	    	  		"Password" => $apipass
	      		),
	      		"shipmentRequest" => array(
		            "ServiceId" => 38,
	            	"ShipFrom" => array(
	            		"PointId" => "",
	                	"ClientTaxId" => '',
	                	"Name" => $sfir != '' ? $sfir : $snaz,
	                	"Address" => getVal('sender/address/address', $ev),
	                	"City" => getVal('sender/address/city', $ev),
	                	"PostCode" => trim(getVal('sender/address/postcode', $ev)),
	                	"CountryCode" => getVal('sender/address/country', $ev),
	                	"Person" => $snaz != '' ? $snaz : $sfir,
	                	"Contact" => getVal('sender/address/telephone', $ev),
		                "Email" => getVal('sender/notification/email[@type=\'delivery\']/@address', $ev),
	                	"IsPrivatePerson" => (getVal('sender/address/type', $ev) == 'private')
	            	),
	            	"ShipTo" => array(
	            		"PointId" => "",
	                	"ClientTaxId" => '',
		                "Name" => $rfir != '' ? $rfir : $rnaz,
	    	            "Address" => getVal('receiver/address/address', $ev),
	        	        "City" => getVal('receiver/address/city', $ev),
	            	    "PostCode" => trim(getVal('receiver/address/postcode', $ev)),
	                	"CountryCode" => getVal('receiver/address/country', $ev),
	                	"Person" => $rnaz != '' ? $rnaz : $rfir,
		                "Contact" => getVal('receiver/contact/telephone', $ev),
	    	            "Email" => getVal('receiver/contact/email', $ev),
	                	"IsPrivatePerson" => (getVal('receiver/address/type', $ev) == 'private')
	            	),
		            "Parcels" => array(),
	            	"COD" => array(
	                	"Amount" => $pobranie,
		                "RetAccountNo" => $konto
	    	        ),
	    	        "InsuranceAmount" => $pobranie != 0 ? $pobranie : $ubez,
	            	"MPK" => "",
	            	"ContentDescription" => '',
	            	"rabateCoupon" => 0,
	            	"LabelFormat" => 'PDF',
	            	"AdditionalServices" => array()
	      		)      		
	        );
			$opisy = array();
			$lpack = $xpath->query('shipment/package', $ev);
			$nst = (getVal('shipment/additional_services/nonstandard', $ev) == 'yes');
			foreach($lpack as $pack) {
				$ref = getVal('description/reference', $pack);
				if($ref != '') {
					$dyrs = explode(',', strtoupper($ref));
					foreach($dyrs as $dyr) $dyrektywy[] = trim($dyr);					
				}
				error_log('dyrektywy=' . print_r($dyrektywy, true));
				
				$op = getVal('description/content_description', $pack);
				foreach($dyrektywy as $dyrektywa)
					switch($dyrektywa) {
						case 'U.NZ':
							$op = ($ev->getAttribute('type') == 'rma') ? 'Reklamacja nr ' . $ev->getAttribute('id') : $ev->getAttribute('id');
							break;
					}
				if(!in_array($op, $opisy)) $opisy[] = $op;
				$waga = getVal('description/weight', $pack);
				$wjm = getVal('description/weight/@unit', $pack);
				if($wjm == 'g') $waga = $waga / 1000;
				if($waga == 0) $waga = 1;
				$rd = getVal('description/dimensions/length', $pack);
				$rw = getVal('description/dimensions/height', $pack);
				$rs = getVal('description/dimensions/width', $pack);
				$rjm = getVal('description/dimensions/@unit', $pack);
				$typ = getVal('description/packaging', $pack);
				if($rjm == 'mm') {
					$rd = $rd / 10;
					$rw = $rw / 10;
					$rs = $rs / 10;
				}
				if($rjm == 'm') {
					$rd = $rd * 100;
					$rw = $rw * 100;
					$rs = $rs * 100;
				}
				if($rd == 0) $rd = 10;
				if($rw == 0) $rw = 10;
				if($rs == 0) $rs = 10;
		       	$params['shipmentRequest']['Parcels']['Parcel'][] = array(
	    	    		"Type" => 'Package',
	        	    	"Weight" => $waga,
	            		"D" => $rd,
	                	"W" => $rw,
	                	"S" => $rs,
	                	"IsNST" => ($typ == 'other') || $nst
		        );
			}
			if(count($params['shipmentRequest']['Parcels']['Parcel']) == 1) $params['shipmentRequest']['Parcels']['Parcel'] = $params['shipmentRequest']['Parcels']['Parcel'][0];
	        $params['shipmentRequest']['ContentDescription'] = join("\n", $opisy);
	        
	        error_log(print_r($params, true));
	    	$response = $client->__soapCall("CreateShipment", array($params));	

			if(!isset($response->CreateShipmentResult->responseDescription) || ($response->CreateShipmentResult->responseDescription != 'Success')) {
				error_log(print_r($response, true));
				addErr($ev, 'E001', 'API error', '[' . $response->CreateShipmentResult->responseCode . '] ' . $response->CreateShipmentResult->responseDescription, '/event/');
	        	return false;
			}

			$opaczki = $response->CreateShipmentResult->ParcelData->Label;
			if(is_object($opaczki)) $opaczki = array($opaczki);
	
			$i = 0;
			$pdfs = array();
			$pids = array();
			$pno = $response->CreateShipmentResult->PackageNo;
			$ntrack = getNode('shipment/tracking_number', $ev);
			$ntrack->appendChild($doc->createTextNode($pno));
	
			$lpack = $xpath->query('shipment/package', $ev);
			foreach($lpack as $pack) {
				$pdfs[] = $opaczki[$i]->MimeData;
				$pid = $opaczki[$i]->ParcelID;
				$opaczki[$i]->MimeData = "[" . strlen($opaczki[$i]->MimeData) . "]";	// Aby w logu nie byo mieci
				$pids[] = $pid;
				$ntrack = getNode('tracking_number', $pack);
				$ntrack->appendChild($doc->createTextNode($pid));		
				$i++;
			}
			error_log(print_r($response, true));

			if(count($pdfs) == 1) $pdf_file = $pdfs[0];
			else {
				$pdf = new Zend_Pdf();
				foreach($pdfs as $p) {
					$pdf1 = Zend_Pdf::parse($p);
					foreach ($pdf1->pages as $page) {
  						$pdf->pages[] = clone $page;
					}
				}
				$pdf_file = $pdf->render();
			}
			$nbase = getNode('shipment/label/base64', $ev);
			$nbase->appendChild($doc->createCDATASection(base64_encode($pdf_file)));
			$nurl = getNode('shipment/tracking_url', $ev);
			$nurl->appendChild($doc->createTextNode(str_replace('@', join(',', $pids), trackUrl)));
	
			$nnet = getNode('shipment/cost/net', $ev);
			$nnet->appendChild($doc->createTextNode("0"));
			$nvp = getNode('shipment/cost/vat_percent', $ev);
			$nvp->appendChild($doc->createTextNode("0"));
			$ngrs = getNode('shipment/cost/gross', $ev);
			$ngrs->appendChild($doc->createTextNode("0"));			
		} catch(Exception $e) {
			error_log('exception! ' . print_r($e, true));
	    	error_log($client->__getLastRequest());
			addErr($ev, 'E002', 'API exception', 'API exception', '/event/');
		}
	}
}

function getNode($q, $ev) {
	global $doc, $xpath;
	
	$l = $xpath->query($q, $ev);
//	error_log('q=' . $q . ' l=' . print_r($l, true));
	if($l->length == 0) return null;
	$n = $l->item(0);
	return $n;
}

function getVal($q, $ev) {
	$n = getNode($q, $ev);
	if($n == null) return '';
	return $n->textContent;
}

function addErr($ev, $kod, $serr, $err, $nod) {
	global $doc;

	$nes = $ev->getElementsByTagname('errors');
	if($nes->length == 1) $ne = $nes->item(0);
	else {
		$ne = $doc->createElement('errors');
		$ev->appendChild($ne);
	}
	$ne1 = $doc->createElement('error');
	$ne->appendChild($ne1);	

	$np = $doc->createElement('priority', 'critical');
	$ne1->appendChild($np);
	$nc = $doc->createElement('code', $kod);
	$ne1->appendChild($nc);
	$ns = $doc->createElement('short_description', $serr);
	$ne1->appendChild($ns);
	$nd = $doc->createElement('description', $err);
	$ne1->appendChild($nd);
	$nn = $doc->createElement('node', $nod);
	$ne1->appendChild($nn);	
}

//error_log(print_r(apache_request_headers(), true));
$json = file_get_contents('php://input');
if($json == '') {
	echo 'ERR';
	error_log('Pusty string!');
	exit;
}

header('Content-type: application/json');
$obj = json_decode($json);
error_log("json=" . print_r($obj, true));

$user = $obj->user;
$apiuser = 'IAI-' . $obj->user . '-' . $obj->hash;
$apipass = $obj->user . hash('sha256', $obj->isf) . '%' . $obj->time;

$doc = new DOMDocument();
if(!$doc->loadXML($obj->isf)) exit;
$xpath = new DOMXpath($doc);
$roots = $doc->getElementsByTagName('set');
if($roots->length != 1) exit;
$root = $roots->item(0);

$evs = $doc->getElementsByTagname('event');
foreach($evs as $ev) doEvent($ev);

$datetime = new DateTime();
$root->setAttribute('author', 'Trucker-IFS gate');
//$root->setAttribute('generated', $datetime->format('c'));

$ret = getJson($doc->saveXML());
echo $ret;
//error_log($ret);

?>
